//+------------------------------------------------------------------+
//|                                                     VininI_Cyber |
//|                                Copyright  2009, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//|                                    non-repainting made by mladen }
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Victor Nicolaev"
#property link      "e-mail: vinin@mail.ru"
#property link      "link: www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Silver
#property indicator_color2 LimeGreen
#property indicator_color3 LimeGreen
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_level1  -0.5
#property indicator_level2   0
#property indicator_level3   0.5
#property indicator_minimum -1.05
#property indicator_maximum  1.05

//---- input parameters 

extern int  WPR_Period=5;
extern int  WPR_Price =0;
extern int  MA_Period =9;
extern int  MA_Method =3;
//---- buffers 

double Value[];
double MA[];
double iFish[];
double Buy[];
double Buyb[];
double Sell[];
double Sellb[];
double cross[];


//+------------------------------------------------------------------+ 
//| Custom indicator initialization function | 
//+------------------------------------------------------------------+ 
int init() { 
   IndicatorBuffers(8);
   SetIndexBuffer(0, iFish); 
   SetIndexBuffer(1, Buy); 
   SetIndexBuffer(2, Buy); 
   SetIndexBuffer(3, Sell); 
   SetIndexBuffer(4, Sell); 

   SetIndexBuffer(5, Value);
   SetIndexBuffer(6, MA);  
   SetIndexBuffer(7, cross);  



   return(0); 
}  

int deinit() { return(0); } 


//+------------------------------------------------------------------+ 
//| Custom indicator iteration function | 
//+------------------------------------------------------------------+ 
int start() { 
   int counted_bars = IndicatorCounted(), i; 

   if (counted_bars < 0) return(-1); 
   if (counted_bars > 0) counted_bars--;
   
   int limit=Bars - counted_bars;
   if (cross[limit]== 1) CleanPoint(limit,Buy ,Buyb );
   if (cross[limit]==-1) CleanPoint(limit,Sell,Sellb);
   for(i = limit; i >= 0; i--)    Value[i]=0.1*(iWPR(NULL,0,WPR_Period,i)+50.0);
   for(i = limit; i >= 0; i--)    MA[i]=iMAOnArray(Value,0,MA_Period,0,MA_Method,i);
   for(i = limit; i >= 0; i--)    {
      iFish[i]=(MathExp(2.0*MA[i])-1.0)/(MathExp(2.0*MA[i])+1.0);
      Buy[i]   = EMPTY_VALUE;
      Buyb[i]  = EMPTY_VALUE;
      Sell[i]  = EMPTY_VALUE;
      Sellb[i] = EMPTY_VALUE;
      cross[i] = 0;
         if (iFish[i]> 0.5) cross[i] =  1;
         if (iFish[i]<-0.5) cross[i] = -1;
         if (cross[i] == 1) PlotPoint(i,Buy ,Buyb ,iFish);
         if (cross[i] ==-1) PlotPoint(i,Sell,Sellb,iFish);
   }
   return(0); 
} 
//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}